<?php
 
$yamip   = '192.168.0.10'; // Yamaha IP
$yamport = '80'; // Yamaha port
  
function send_to_host($host,$port,$method,$path='/',$data=''){
    $buf="";
    $method = strtoupper($method);
    $fp = fsockopen($host, $port) or die("Unable to open socket");

    fputs($fp, "$method $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp, "Content-type: text/xml\r\n");
    if ($method == 'POST') fputs($fp, "Content-length: " . strlen($data) . "\r\n");
    fputs($fp, "Connection: close\r\n\r\n");

    if ($method == 'POST') fputs($fp, $data);

    while (!feof($fp))
      $buf .= fgets($fp,256);
   
    fclose($fp);
    return $buf;
}

$COMMAND = [//STATUS
  				"STATUS"	=> "<YAMAHA_AV cmd=\"GET\"><Main_Zone><Basic_Status>GetParam</Basic_Status></Main_Zone></YAMAHA_AV>",
  
  			// SYSTEM
  				"CEC_ON"	=> "<YAMAHA_AV cmd=\"PUT\"><System><Sound_Video><HDMI><Control>On</Control></HDMI></Sound_Video></System></YAMAHA_AV>",
  				"CEC_OFF"	=> "<YAMAHA_AV cmd=\"PUT\"><System><Sound_Video><HDMI><Control>Off</Control></HDMI></Sound_Video></System></YAMAHA_AV>",
  
  			//POWER
  				"POWER_ON"	 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Power_Control><Power>On</Power></Power_Control></Main_Zone></YAMAHA_AV>",
             	"POWER_OFF" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Power_Control><Power>Standby</Power></Power_Control></Main_Zone></YAMAHA_AV>",
  				"POWER_TOGGLE" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Power_Control><Power>On/Standby</Power></Power_Control></Main_Zone></YAMAHA_AV>",
            
            //VOLUME
				"MUTE" 				=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Mute>On/Off</Mute></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_UP" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Up</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_DOWN" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Down</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_UP_1DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Up 1 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_DOWN_1DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Down 1 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_UP_2DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Up 2 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_DOWN_2DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Down 2 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_UP_5DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Up 5 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_DOWN_5DB" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>Down 5 dB</Val><Exp></Exp><Unit></Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
				"VOLUME_TRIM" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Volume><Lvl><Val>#PARAM#0</Val><Exp>1</Exp><Unit>dB</Unit></Lvl></Volume></Main_Zone></YAMAHA_AV>",
  
			//AUDIO
				"AUDIO_2CH_STEREO" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Sound_Program>2ch Stereo</Sound_Program></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_7CH_STEREO" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Sound_Program>7ch Stereo</Sound_Program></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_STRAIGHT_OFF" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Straight>Off</Straight></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_STRAIGHT_ON" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Straight>On</Straight></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_ENHANCER_OFF" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Enhancer>Off</Enhancer></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_ENHANCER_ON" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Surround><Program_Sel><Current><Enhancer>On</Enhancer></Current></Program_Sel></Surround></Main_Zone></YAMAHA_AV>",
				"AUDIO_AUTO" 			=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Decoder_Sel><Current>Auto</Current></Decoder_Sel></Input></Main_Zone></YAMAHA_AV>",
				"AUDIO_DTS" 			=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Decoder_Sel><Current>DTS</Current></Decoder_Sel></Input></Main_Zone></YAMAHA_AV>",

			//INPUT
				"INP_HDMI1" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI1</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_HDMI2" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI2</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_HDMI3" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI3</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_HDMI4" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI4</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_HDMI5" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI5</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_HDMI6" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>HDMI6</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_AV1" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>AV1</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_AV2" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>AV2</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_AV3" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>AV3</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_AUDIO1" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>AUDIO1</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_AUDIO2" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>AUDIO2</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_USB" 		=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>USB</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
				"INP_TUNER" 	=> "<YAMAHA_AV cmd=\"PUT\"><Main_Zone><Input><Input_Sel>TUNER</Input_Sel></Input></Main_Zone></YAMAHA_AV>",
  
			];


if($argc<3) {
	die("Paramètres manquants");
}
$cmdType = strtoupper($argv[1]);
$cmd = strtoupper($argv[2]);
$cmdParam = ($argc>3) ?strtoupper($argv[3]) : '';

if ($cmdType=="GET") {

   $request = send_to_host($yamip, $yamport, 'POST', '/YamahaRemoteControl/ctrl', $COMMAND['STATUS']);
   $response = explode("Connection: close",$request);
   $parsed = simplexml_load_string($response[1]);

  switch ($cmd) {
      case "STATUS":
          echo ($parsed->Main_Zone->Basic_Status->Power_Control->Power=='On') ? 1:0;
          break;
      case "VOLUME":
          echo $parsed->Main_Zone->Basic_Status->Volume->Lvl->Val;
          break;
      case "MUTE":
      		//echo htmlentities($response[1]);
          echo ($parsed->Main_Zone->Basic_Status->Volume->Mute=='On') ? 1:0;
          break;
      case "INPUT":
          echo $parsed->Main_Zone->Basic_Status->Input->Input_Sel;
          break;
      case "INPUT_NAME":
          echo $parsed->Main_Zone->Basic_Status->Input->Input_Sel_Item_Info->Title;
          break;
	}
  
} elseif ($cmdType=="PUT" || $cmdType=="SET" ) {
  
  if(isset($COMMAND[$cmd])) {
     $request = send_to_host($yamip, $yamport, 'POST', '/YamahaRemoteControl/ctrl', str_replace('#PARAM#', $cmdParam , $COMMAND[$cmd]));
     $response = explode("Connection: close",$request);
     //echo htmlentities($response[1]);
  } else {
    die ("Commande $cmd inconnue");
  }
  
}

